//
// MigraDoc - Creating Documents on the Fly
//
// This is a part of the empira MigraDoc Document Object Model.
//
// Copyright (c) 2002-2005 empira Software GmbH, Cologne (Germany)
// All rights reserved
//
// http://www.pdfsharp.com
//
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

using System;
using System.Collections;
using System.Diagnostics;
using System.Globalization;
using System.Reflection;

//TODO Datei ist undokumentiert.

namespace MigraDoc.DocumentObjectModel.Internals
{
  /// <summary>
  /// 
  /// </summary>
  public class ValueDescriptorCollection : IEnumerable
  {
    public int Count
    {
      get {return this.arrayList.Count;}
    }

    public int Add(ValueDescriptor vd)
    {
      this.hashTable.Add(vd.ValueName, vd);
      return this.arrayList.Add(vd);
    }

    public ValueDescriptor this[int index]
    {
      get {return this.arrayList[index] as ValueDescriptor;}
    }

    public ValueDescriptor this[string name]
    {
      get {return this.hashTable[name] as ValueDescriptor;}
    }

    public IEnumerator GetEnumerator()
    {
      return this.arrayList.GetEnumerator();
    }

    ArrayList arrayList = new ArrayList();
#if NET_2_0
    Hashtable hashTable = new Hashtable(StringComparer.InvariantCultureIgnoreCase);
#else
    Hashtable hashTable = new Hashtable(CaseInsensitiveHashCodeProvider.DefaultInvariant, CaseInsensitiveComparer.DefaultInvariant);
#endif
  }
}
