using System;
using MigraDoc.DocumentObjectModel;
using MigraDoc.DocumentObjectModel.Shapes;
using MigraDoc.DocumentObjectModel.Fields;

namespace HelloMigraDoc
{
  public class TableOfContents
  {
    /// <summary>
    /// Defines the cover page.
    /// </summary>
    public static void DefineTableOfContents(Document document)
    {
      Section section = document.LastSection;
      Paragraph paragraph;
      Hyperlink hyperlink;

      section.AddPageBreak();
      paragraph = section.AddParagraph("Table of Contents");
      paragraph.Format.Font.Size = 14;
      paragraph.Format.Font.Bold = true;
      paragraph.Format.SpaceAfter = 24;
      paragraph.Format.OutlineLevel = OutlineLevel.Level1;

      paragraph = section.AddParagraph();
      paragraph.Style = "TOC";
      hyperlink = paragraph.AddHyperlink("Paragraphs");
      hyperlink.AddText("Paragraphs\t");
      hyperlink.AddPageRefField("Paragraphs");

      paragraph = section.AddParagraph();
      paragraph.Style = "TOC";
      hyperlink = paragraph.AddHyperlink("Tables");
      hyperlink.AddText("Tables\t");
      hyperlink.AddPageRefField("Tables");

      paragraph = section.AddParagraph();
      paragraph.Style = "TOC";
      hyperlink = paragraph.AddHyperlink("Charts");
      hyperlink.AddText("Charts\t");
      hyperlink.AddPageRefField("Charts");
    }
  }
}
