using System;
using System.Diagnostics;
using MigraDoc.DocumentObjectModel;
using MigraDoc.Rendering;

namespace HelloWorld
{
  /// <summary>
  /// This sample is the obligatory Hello World program for MigraDoc documents.
  /// </summary>
  class Programm
  {
    [STAThread]
    static void Main(string[] args)
    {
      // Create a MigraDoc document
      Document document = CreateDocument();

      string ddl = MigraDoc.DocumentObjectModel.IO.DdlWriter.WriteToString(document);

      PdfPrinter printer = new PdfPrinter();
      printer.Document = document;

      printer.PrintDocument();

      // Save the document...
      string filename = "HelloWorld.pdf";
      printer.PdfDocument.Save(filename);
      // ...and start a viewer.
      Process.Start(filename);
    }

    /// <summary>
    /// Creates an absolutely minimalistic document.
    /// </summary>
    static Document CreateDocument()
    {
      // Create a new MigraDoc document
      Document document = new Document();

      // Add a section to the document
      Section section = document.AddSection();

      // Add a paragraph to the section
      Paragraph paragraph = section.AddParagraph();

      // Add some text to the paragraph
      paragraph.AddFormattedText("Hello, World!", TextFormat.Italic);

      return document;
    }
  }
}
